Bug 1071210 (CVE-2014-6512) - CVE-2014-6512 OpenJDK: DatagramSocket connected socket missing source check (Libraries, 8039509)
Summary: CVE-2014-6512 OpenJDK: DatagramSocket connected socket missing source check (...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2014-6512
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard: impact=low,public=20141014,reported=2...
Depends On:
Blocks: 1072483 1148726
TreeView+ depends on / blocked
 
Reported: 2014-02-28 09:37 UTC by Tomas Hoger
Modified: 2019-06-08 19:56 UTC (History)
12 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
It was discovered that the DatagramSocket implementation in OpenJDK failed to perform source address checks for packets received on a connected socket. A remote attacker could use this flaw to have their packets processed as if they were received from the expected source.
Clone Of:
Environment:
Last Closed: 2014-11-24 17:15:37 UTC


Attachments (Terms of Use)
DatagramSocket-connect-9-untested.patch (9.69 KB, patch)
2014-02-28 10:03 UTC, Florian Weimer
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2014:1620 normal SHIPPED_LIVE Important: java-1.7.0-openjdk security and bug fix update 2014-10-15 05:26:31 UTC
Red Hat Product Errata RHSA-2014:1633 normal SHIPPED_LIVE Important: java-1.7.0-openjdk security and bug fix update 2014-10-15 00:47:46 UTC
Red Hat Product Errata RHSA-2014:1634 normal SHIPPED_LIVE Important: java-1.6.0-openjdk security and bug fix update 2014-10-15 06:09:01 UTC
Red Hat Product Errata RHSA-2014:1636 normal SHIPPED_LIVE Important: java-1.8.0-openjdk security update 2014-10-15 07:03:25 UTC
Red Hat Product Errata RHSA-2014:1657 normal SHIPPED_LIVE Critical: java-1.7.0-oracle security update 2017-12-15 15:36:32 UTC
Red Hat Product Errata RHSA-2014:1658 normal SHIPPED_LIVE Important: java-1.6.0-sun security update 2017-12-15 15:35:40 UTC
Red Hat Product Errata RHSA-2014:1876 normal SHIPPED_LIVE Critical: java-1.7.0-ibm security update 2014-11-19 23:32:13 UTC
Red Hat Product Errata RHSA-2014:1877 normal SHIPPED_LIVE Critical: java-1.6.0-ibm security update 2014-11-19 23:32:00 UTC
Red Hat Product Errata RHSA-2014:1880 normal SHIPPED_LIVE Critical: java-1.7.1-ibm security update 2014-11-20 21:31:54 UTC
Red Hat Product Errata RHSA-2014:1881 normal SHIPPED_LIVE Important: java-1.5.0-ibm security update 2014-11-20 21:16:53 UTC
Red Hat Product Errata RHSA-2014:1882 normal SHIPPED_LIVE Critical: java-1.7.0-ibm security update 2014-12-03 00:43:08 UTC
Red Hat Product Errata RHSA-2015:0264 normal SHIPPED_LIVE Low: Red Hat Satellite IBM Java Runtime security update 2015-02-24 18:44:15 UTC

Description Tomas Hoger 2014-02-28 09:37:59 UTC
It was discovered that DatagramSocket implementation in OpenJDK did not perform any packet source address checks for packets received on connected socket.  This could cause an application using DatagramSocket to read a packet from the socket that originates from a different source to the one to which the socket was connected.  This problem is caused by BSD socket API oddity, which returns packets form different source if they were queued before socket was connected.

This issue can make it easier to perform IP spoofing attacks, as it may allow packets to be processed by an application without packets actually having spoofed source address.  It can also lead to limited security manager restrictions bypass.

http://docs.oracle.com/javase/7/docs/api/java/net/DatagramSocket.html

Acknowledgement:

This issue was discovered by Florian Weimer of Red Hat Product Security.

Comment 2 Florian Weimer 2014-02-28 10:03:44 UTC
Created attachment 868938 [details]
DatagramSocket-connect-9-untested.patch

Untested patch against OpenJDK 9.  For DatagramSocket, it adds filtering in the socket class itself.  For DatagramChannel, the filter is directly in the native code.

Comment 15 Tomas Hoger 2014-10-14 20:06:48 UTC
Public now via Oracle Critical Patch Update - October 2014.  Fixed in Oracle Java SE 5.0u75, 6u85, 7u71, and 8u25.

External References:

http://www.oracle.com/technetwork/topics/security/cpuoct2014-1972960.html#AppendixJAVA

Comment 16 errata-xmlrpc 2014-10-14 20:47:59 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 5

Via RHSA-2014:1633 https://rhn.redhat.com/errata/RHSA-2014-1633.html

Comment 17 errata-xmlrpc 2014-10-15 01:26:48 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6
  Red Hat Enterprise Linux 7

Via RHSA-2014:1620 https://rhn.redhat.com/errata/RHSA-2014-1620.html

Comment 18 errata-xmlrpc 2014-10-15 02:09:24 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6
  Red Hat Enterprise Linux 7
  Red Hat Enterprise Linux 5

Via RHSA-2014:1634 https://rhn.redhat.com/errata/RHSA-2014-1634.html

Comment 19 errata-xmlrpc 2014-10-15 03:03:35 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6

Via RHSA-2014:1636 https://rhn.redhat.com/errata/RHSA-2014-1636.html

Comment 20 Martin Prpič 2014-10-15 09:37:07 UTC
IssueDescription:

It was discovered that the DatagramSocket implementation in OpenJDK failed to perform source address checks for packets received on a connected socket. A remote attacker could use this flaw to have their packets processed as if they were received from the expected source.

Comment 22 errata-xmlrpc 2014-10-16 23:02:19 UTC
This issue has been addressed in the following products:

  Oracle Java for Red Hat Enterprise Linux 7
  Oracle Java for Red Hat Enterprise Linux 6
  Oracle Java for Red Hat Enterprise Linux 5

Via RHSA-2014:1658 https://rhn.redhat.com/errata/RHSA-2014-1658.html

Comment 23 errata-xmlrpc 2014-10-16 23:12:34 UTC
This issue has been addressed in the following products:

  Oracle Java for Red Hat Enterprise Linux 7
  Oracle Java for Red Hat Enterprise Linux 6
  Oracle Java for Red Hat Enterprise Linux 5

Via RHSA-2014:1657 https://rhn.redhat.com/errata/RHSA-2014-1657.html

Comment 24 errata-xmlrpc 2014-11-19 18:32:27 UTC
This issue has been addressed in the following products:

  Supplementary for Red Hat Enterprise Linux 5
  Supplementary for Red Hat Enterprise Linux 6

Via RHSA-2014:1877 https://rhn.redhat.com/errata/RHSA-2014-1877.html

Comment 25 errata-xmlrpc 2014-11-19 18:33:17 UTC
This issue has been addressed in the following products:

  Supplementary for Red Hat Enterprise Linux 5

Via RHSA-2014:1876 https://rhn.redhat.com/errata/RHSA-2014-1876.html

Comment 26 errata-xmlrpc 2014-11-20 16:18:44 UTC
This issue has been addressed in the following products:

  Supplementary for Red Hat Enterprise Linux 6

Via RHSA-2014:1882 https://rhn.redhat.com/errata/RHSA-2014-1882.html

Comment 27 errata-xmlrpc 2014-11-20 16:32:31 UTC
This issue has been addressed in the following products:

  Supplementary for Red Hat Enterprise Linux 6
  Supplementary for Red Hat Enterprise Linux 7

Via RHSA-2014:1880 https://rhn.redhat.com/errata/RHSA-2014-1880.html

Comment 28 errata-xmlrpc 2014-11-20 16:52:45 UTC
This issue has been addressed in the following products:

  Supplementary for Red Hat Enterprise Linux 5
  Supplementary for Red Hat Enterprise Linux 6

Via RHSA-2014:1881 https://rhn.redhat.com/errata/RHSA-2014-1881.html

Comment 29 errata-xmlrpc 2015-02-24 13:44:34 UTC
This issue has been addressed in the following products:

  Red Hat Satellite Server v 5.6

Via RHSA-2015:0264 https://rhn.redhat.com/errata/RHSA-2015-0264.html


Note You need to log in before you can comment on or make changes to this bug.